<?php
# Prosty program do wysyania zawartoci formularza z zacznikami
# Autor: Adam Major , v2.0, 1.08.2006
# Copyright:   FreshDATA, http://www.freshdata.pl
# Licencja : BSD,  moesz dowolnie uywa to oprogramowanie do celw komercyjnych i nie komercyjnych, a
# take modyfikowa je w dowolnym zakresie.

# Konfiguracja

// Domylne ustawienia dla formularza - uywane do wysania wiadomoci
$def['email_from'] 	= 'ustaw_jakis_adres@freshdata.pl';   // adres OD  
$def['email_to'] 		= 'ustaw_jakis_adres@freshdata.pl';   // adresat wiadomoci
$def['email_charset']	= 'ISO-8859-2';          // kodowanie powinno by zgodne z kodowaniem strony
$def['email_subject']	= 'tytu wiadomoci';    // tytu maila
$def['return_page']	= 'http://strona/na/ktora/chcemy/wrocic'; // adres do strony z komunikatem
$def['overwrite']		= 0;  // jeli 1 to w/w opcje mog by zmienione w formularzu HTML (nie jest to bezpieczne)

# Koniec konfiguracji


function make_safe_name($file_name)
{
$file_name = strtr($file_name, "\xb1\xe6\xea\xf3\xb3\xb6\xbf\xbc\xf1\xa1\xc6\xca\xd3\xa3\xa6\xaf\xac\xd1\xA5\x8C\x8F\xB9\x9C\x9F",
"aceolszznACEOLSZZNASZasz");

$pos = strrpos($file_name, '.');
$ext = substr($file_name, $pos); 

$file_name = str_replace(' ', '_', substr($file_name, 0, $pos)); 
$file_name = preg_replace('/[^a-z0-9_-]/i', '', $file_name);	

$file_name .= $ext;

return $file_name;	
} 
 


function send_mail()
{
global $def;

$no_send = array('submit', 'MAX_FILE_SIZE');

if ($def['overwrite'] == 1)
	{
	foreach ($def as $k=>$v)
		if ($_POST[$k] != '')
			{
			 $def[$k] = $_POST[$k];
			 $no_send[] = $k;
			}	
	}
$body = '';

foreach($_POST as $k=>$v)
	{
	if (in_array($k, $no_send)) continue;
	$body .= $k . ': ' . $v . "\n"; 
	}
	
$headers = "From: $def[email_from]\n";

// czy sa jakies dobrze przegrane pliki
if (count($_FILES) > 0)
	{
	foreach ($_FILES as $k => $v)
		if ($v['error'] == 0)
			{
			$attachments = 1;
			break;
			}
	
	}


if ($attachments == 1)
	{
	$boundary = md5(uniqid(rand()));
		
	$headers .= "MIME-Version: 1.0\n"; 
	$headers .= "Content-Type: multipart/mixed; boundary=\"$boundary\"\n"; 
		
	$message .= "--$boundary\n"; 
	$message .= "Content-Type: text/plain; charset=$def[email_charset]\n"; 
	$message .= "Content-Transfer-Encoding: 7bit\n\n"; 
	$message .= $body;
	
	foreach ($_FILES as $k => $v)
		{
		// zle przegrany plik wiec out bez powiadomiania
		if ($v['error'] != 0) continue;
		$filename = make_safe_name($v['name']);
		
		// pobieranie pliku
		$fp = fopen($v['tmp_name'], 'r');
		$f_content = chunk_split(base64_encode(fread($fp, filesize($v['tmp_name'])))); 
		fclose($fp);
		
		$message .= "--$boundary\n";
		$message .= "Content-Type: {$v['type']}; name=\"$filename\"\n";
		$message .= "Content-Transfer-Encoding: base64\n";
		$message .= "Content-Disposition: attachment; filename=\"$filename\"\n\n";

		$message .= $f_content."\n\n"; 
		
		unset ($f_content);
		}

	
	$message .= "--$boundary--\n\n"; 
	
	$body = $message;
	}
else $headers .= "Content-Type: text/plain; charset=\"$def[email_charset]\"";
	

mail($def['email_to'], $def['email_subject'], $body, $headers);

header("location: {$def['return_page']}");
exit;
} // END send_mail()

if ($_SERVER['REQUEST_METHOD'] == 'POST') send_mail();
?>